Subject: Re: Using Expanded Objects other than Arrays from plpgsql

From: Tom Lane <[email-masked]>
Date: Sun, 20 Oct 2024 15:19:00 -0400

Michel Pelletier <[email-masked]> writes:
> On Sun, Oct 20, 2024 at 10:13 AM Tom Lane <[email-masked]> wrote:
>> The other problem is that plpgsql only knows how to do such expansion
>> for arrays, and it's not obvious how to extend that part.

> Perhaps a third member function for ExpandedObjectMethods that formalizes
> the expansion interface like found in DatumGetExpandedArray?  I closely
> follow that same pattern in my code.

The trouble is we don't have an expanded object to consult at this
point --- only a flat Datum.  plpgsql has hard-wired knowledge that
it's okay to apply expand_array if the datatype passes the typisarray
tests, but I'm pretty unclear on how to provide similar knowledge for
extension datatypes.

			regards, tom lane